Wt: Wt::WPushButton Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WPushButton Class Reference

A widget that represents a push button. More...

`#include <Wt/WPushButton.h>`

Inheritance diagram for Wt::WPushButton:
[legend]

## Public Member Functions
| WPushButton ()
| Creates a push button.
| WPushButton (const WString &text)
| Creates a push button with given label text.
| WPushButton (const WString &text, TextFormat textFormat)
| Creates a push button with given label text.
void | setDefault (bool enabled)
| Sets the default property.
bool | isDefault () const
| Returns whether the button is a default button.
void | setCheckable (bool checkable)
| Sets whether the button is checkable.
bool | isCheckable () const
| Returns whether a button is checkable.
void | setChecked (bool checked)
| Sets the button state.
void | setChecked ()
| Checks the button.
void | setUnChecked ()
| Unchecks the button.
bool | isChecked () const
| Returns the button state.
bool | setText (const WString &text)
| Sets the button text.
const WString & | text () const
| Returns the button text.
bool | setTextFormat (TextFormat format)
| Sets the text format.
TextFormat | textFormat () const
| Returns the text format.
void | setIcon (const WLink &link)
| Sets an icon.
WLink | icon () const
| Returns the icon.
void | setLink (const WLink &link)
| Sets a destination link.
const WLink & | link () const
| Returns the destination link.
virtual WString | valueText () const override
| Returns the current value.
virtual void | setValueText (const WString &value) override
| Sets the current value.
void | setMenu (std::unique_ptr< WPopupMenu > menu)
| Links a popup menu to the button.
WPopupMenu * | menu () const
| Returns an associated popup menu.
virtual void | refresh () override
| Refresh the widget.
EventSignal & | checked ()
| Signal emitted when the button gets checked.
EventSignal & | unChecked ()
| Signal emitted when the button gets unchecked.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
Public Member Functions inherited from Wt::WFormWidget
| WFormWidget ()
| Creates a WFormWidget.
| ~WFormWidget ()
| Destructor.
WLabel * | label () const
| Returns the label associated with this widget.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Sets the hidden state of this widget.
void | setValidator (const std::shared_ptr< WValidator > &validator)
| Sets a validator for this field.
virtual std::shared_ptr< WValidator > | validator () const
| Returns the validator.
virtual ValidationState | validate ()
| Validates the field.
void | setEnabled (bool enabled)
| Sets whether the widget is enabled.
virtual void | setReadOnly (bool readOnly)
| Sets the element read-only.
bool | isReadOnly () const
| Returns whether the form element is read-only.
virtual void | setPlaceholderText (const WString &placeholder)
| Sets the placeholder text.
const WString & | placeholderText () const
| Returns the placeholder text.
EventSignal & | changed ()
| Signal emitted when the value was changed.
Signal< WValidator::Result > & | validated ()
| Signal emitted when the widget is being validated.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual int | tabIndex () const override
| Returns the tab index.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
Protected Member Functions inherited from Wt::WFormWidget
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WInteractWidget
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WFormWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WFormWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that represents a push button.

To act on a button click, connect a slot to the clicked() signal.

Usage example:

// container is a WContainerWidget*
Wt::WPushButton *ok =
container->addWidget(std::make_unique<Wt::WPushButton>("Okay"));
ok->clicked().connect(ok, &Wt::WPushButton::disable);
ok->clicked().connect(this, &MyClass::processData);
Wt::WInteractWidget::clicked
EventSignal< WMouseEvent > & clicked()
Event signal emitted when the primary mouse button was clicked on this widget.
Wt::WPushButton
A widget that represents a push button.
Definition WPushButton.h:42
Wt::WWidget::disable
void disable()
Disable thes widget.

WPushButton is an inline widget.

### CSS

The widget corresponds to the HTML `<button>` tag (with some exceptions in the bootstrap theme).

## Constructor & Destructor Documentation

## ◆ WPushButton()

Wt::WPushButton::WPushButton | ( | const WString & | text | ) |

Creates a push button with given label text.

The default text format is TextFormat::Plain.

## Member Function Documentation

## ◆ checked()

EventSignal & Wt::WPushButton::checked | ( |  | ) |

Signal emitted when the button gets checked.

This signal is emitted when the user checks the button.

You can use the clicked() signal to react to any change of the button state.

See also
  setCheckable()

## ◆ enableAjax()

virtual void Wt::WPushButton::enableAjax | ( |  | ) |
| overrideprotectedvirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WFormWidget.

## ◆ icon()

WLink Wt::WPushButton::icon | ( |  | ) | const

Returns the icon.

See also
  setIcon()

## ◆ isCheckable()

bool Wt::WPushButton::isCheckable | ( |  | ) | const

Returns whether a button is checkable.

See also
  setCheckable()

## ◆ isChecked()

bool Wt::WPushButton::isChecked | ( |  | ) | const

Returns the button state.

See also
  setChecked()

## ◆ isDefault()

bool Wt::WPushButton::isDefault | ( |  | ) | const

Returns whether the button is a default button.

See also
  setDefault()

## ◆ link()

const WLink & Wt::WPushButton::link | ( |  | ) | const

Returns the destination link.

See also
  setLink()

## ◆ menu()

WPopupMenu * Wt::WPushButton::menu | ( |  | ) | const

Returns an associated popup menu.

See also
  setMenu()

## ◆ propagateSetEnabled()

virtual void Wt::WPushButton::propagateSetEnabled | ( | bool | enabled | ) |
| overrideprotectedvirtual

Propagates that a widget was enabled or disabled through children.

When enabling or disabling a widget, you usually also want to disable contained children. This method is called by setDisabled() to propagate its state to all children.

You may want to reimplement this method if they wish to render differently when a widget is disabled. The default implementation will propagate the signal to all children.

Reimplemented from Wt::WFormWidget.

## ◆ refresh()

virtual void Wt::WPushButton::refresh | ( |  | ) |
| overridevirtual

Refresh the widget.

The refresh method is invoked when the locale is changed using WApplication::setLocale() or when the user hit the refresh button.

The widget must actualize its contents in response.

Note
  This does not rerender the widget! Calling refresh() usually does not have any effect (unless you've reimplemented refresh() to attach to it an effect).

Reimplemented from Wt::WFormWidget.

## ◆ setCheckable()

void Wt::WPushButton::setCheckable | ( | bool | checkable | ) |

Sets whether the button is checkable.

A checkable button can be checked and unchecked, and clicking will toggle between these two states.

See also
  setChecked(bool)

## ◆ setChecked() [1/2]

void Wt::WPushButton::setChecked | ( |  | ) |

Checks the button.

Does not emit the checked() signal.

See also
  setChecked(bool)

## ◆ setChecked() [2/2]

void Wt::WPushButton::setChecked | ( | bool | checked | ) |

Sets the button state.

This is ignored for a button which is not checkable.

This method does not emit one of the checked() or unChecked() signals.

See also
  setCheckable(), setChecked(), setUnChecked()

## ◆ setDefault()

void Wt::WPushButton::setDefault | ( | bool | enabled | ) |

Sets the default property.

This has only a functional meaning for a button in a dialog footer, as it becomes associated with pressing 'enter' in the dialog.

A default button may be rendered in a different style, depending on the theme.

## ◆ setFirstFocus()

virtual bool Wt::WPushButton::setFirstFocus | ( |  | ) |
| overridevirtual

Set focus on the widget's first descendant.

Set focus on the widget itself, or on a first descendant which can receive focus.

Returns whether focus could be set.

Reimplemented from Wt::WWebWidget.

## ◆ setIcon()

void Wt::WPushButton::setIcon | ( | const WLink & | link | ) |

Sets an icon.

The icon is placed to the left of the text.

## ◆ setLink()

void Wt::WPushButton::setLink | ( | const WLink & | link | ) |

Sets a destination link.

This method can be used to make the button behave like a WAnchor (or conversely, an anchor look like a button) and redirect to another URL when clicked.

The `link` may be to a URL, a resource, or an internal path.

By default, a button does not link to an URL and you should listen to the clicked() signal to react to a click event.

Warning
  In Bootstrap theme, you should set a link before it's rendered since it commit's the button to be rendered as an anchor. (see also http://redmine.emweb.be/issues/1802).

## ◆ setMenu()

void Wt::WPushButton::setMenu | ( | std::unique_ptr< WPopupMenu > | menu | ) |

Links a popup menu to the button.

When the button is clicked, the linked popup menu is shown.

## ◆ setText()

bool Wt::WPushButton::setText | ( | const WString & | text | ) |

Sets the button text.

The default text format is Wt::TextFormat::Plain.

When the current text format is Wt::TextFormat::XHTML, and `text` is literal (not created using WString::tr()), it is parsed using an XML parser which discards malicious tags and attributes silently. When the parser encounters an XML parse error, the textFormat is changed to Wt::TextFormat::Plain. If `text` is not a literal, the same parser is applied only when the text is resolved.

Returns whether the text could be set using the current textFormat. A return value of `false` indicates that the text format was changed in order to be able to accept the new text.

See also
  setTextFormat()

## ◆ setTextFormat()

bool Wt::WPushButton::setTextFormat | ( | TextFormat | format | ) |

Sets the text format.

The textFormat controls how the string should be interpreted: either as plain text, which is displayed literally, or as XHTML-markup.

When changing the textFormat to Wt::TextFormat::XHTML, and the current text is literal (not created using WString::tr()), the current text is parsed using an XML parser which discards malicious tags and attributes silently. When the parser encounters an XML parse error, the textFormat is left unchanged, and this method returns false.

Returns whether the textFormat could be set for the current text.

The default format is Wt::TextFormat::Plain.

## ◆ setUnChecked()

void Wt::WPushButton::setUnChecked | ( |  | ) |

Unchecks the button.

Does not emit the unChecked() signal.

See also
  setChecked(bool)

## ◆ setValueText()

virtual void Wt::WPushButton::setValueText | ( | const WString & | value | ) |
| overridevirtual

Sets the current value.

Has no effect, since a button has not value.

Implements Wt::WFormWidget.

## ◆ text()

const WString & Wt::WPushButton::text | ( |  | ) | const

Returns the button text.

See also
  setText()

## ◆ textFormat()

TextFormat Wt::WPushButton::textFormat | ( |  | ) | const

Returns the text format.

See also
  setTextFormat()

## ◆ unChecked()

EventSignal & Wt::WPushButton::unChecked | ( |  | ) |

Signal emitted when the button gets unchecked.

This signal is emitted when the user unchecks the button.

You can use the clicked() signal to react to any change of the button state.

See also
  setCheckable()

## ◆ valueText()

virtual WString Wt::WPushButton::valueText | ( |  | ) | const
| overridevirtual

Returns the current value.

Returns an empty string, since a button has no value.

Implements Wt::WFormWidget.